// THIS IS AN AUTOGENERATED FILE. DO NOT EDIT THIS FILE DIRECTLY.

import { z } from 'zod';

import { GeneratedSchema, Guard } from '../foundations';
import { PasswordEncryptionMethod } from './custom-types';

export type UserUpdate = {
  id: string;
  username?: string | null;
  primaryEmail?: string | null;
  primaryPhone?: string | null;
  passwordEncrypted?: string | null;
  passwordEncryptionMethod?: PasswordEncryptionMethod | null;
  passwordEncryptionSalt?: string | null;
};

export type User = {
  id: string;
  username: string | null;
  primaryEmail: string | null;
  primaryPhone: string | null;
  passwordEncrypted: string | null;
  passwordEncryptionMethod: PasswordEncryptionMethod | null;
  passwordEncryptionSalt: string | null;
};

const guard: Guard<UserUpdate> = z.object({
  id: z.string(),
  username: z.string().optional(),
  primaryEmail: z.string().optional(),
  primaryPhone: z.string().optional(),
  passwordEncrypted: z.string().optional(),
  passwordEncryptionMethod: z.nativeEnum(PasswordEncryptionMethod).optional(),
  passwordEncryptionSalt: z.string().optional(),
});

export const Users: GeneratedSchema<UserUpdate> = Object.freeze({
  table: 'users',
  tableSingular: 'user',
  fields: {
    id: 'id',
    username: 'username',
    primaryEmail: 'primary_email',
    primaryPhone: 'primary_phone',
    passwordEncrypted: 'password_encrypted',
    passwordEncryptionMethod: 'password_encryption_method',
    passwordEncryptionSalt: 'password_encryption_salt',
  },
  fieldKeys: [
    'id',
    'username',
    'primaryEmail',
    'primaryPhone',
    'passwordEncrypted',
    'passwordEncryptionMethod',
    'passwordEncryptionSalt',
  ],
  guard,
});
